# coding: utf-8

"""
    Assetic Integration API

    No descripton provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class AssessmentTaskApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def assessment_task_get(self, **kwargs):
        """
        Gets assessment tasks
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.assessment_task_get(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int request_params_page: 
        :param int request_params_page_size: 
        :param list[str] request_params_sorts: 
        :param list[str] request_params_filters: 
        :return: Assetic3IntegrationRepresentationsAsmtTaskListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.assessment_task_get_with_http_info(**kwargs)
        else:
            (data) = self.assessment_task_get_with_http_info(**kwargs)
            return data

    def assessment_task_get_with_http_info(self, **kwargs):
        """
        Gets assessment tasks
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.assessment_task_get_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int request_params_page: 
        :param int request_params_page_size: 
        :param list[str] request_params_sorts: 
        :param list[str] request_params_filters: 
        :return: Assetic3IntegrationRepresentationsAsmtTaskListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method assessment_task_get" % key
                )
            params[key] = val
        del params['kwargs']

        resource_path = '/api/v2/assessmenttask'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Assetic3IntegrationRepresentationsAsmtTaskListRepresentation',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def assessment_task_get_0(self, id, **kwargs):
        """
        Gets details of a given assessment task
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.assessment_task_get_0(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Assessment task id (required)
        :return: Assetic3IntegrationRepresentationsAsmtTaskRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.assessment_task_get_0_with_http_info(id, **kwargs)
        else:
            (data) = self.assessment_task_get_0_with_http_info(id, **kwargs)
            return data

    def assessment_task_get_0_with_http_info(self, id, **kwargs):
        """
        Gets details of a given assessment task
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.assessment_task_get_0_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Assessment task id (required)
        :return: Assetic3IntegrationRepresentationsAsmtTaskRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method assessment_task_get_0" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `assessment_task_get_0`")

        resource_path = '/api/v2/assessmenttask/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Assetic3IntegrationRepresentationsAsmtTaskRepresentation',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def assessment_task_link_asmt_form_result(self, id, form_result_id, **kwargs):
        """
        Links Assessment Form Result to Task
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.assessment_task_link_asmt_form_result(id, form_result_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id:  (required)
        :param str form_result_id:  (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.assessment_task_link_asmt_form_result_with_http_info(id, form_result_id, **kwargs)
        else:
            (data) = self.assessment_task_link_asmt_form_result_with_http_info(id, form_result_id, **kwargs)
            return data

    def assessment_task_link_asmt_form_result_with_http_info(self, id, form_result_id, **kwargs):
        """
        Links Assessment Form Result to Task
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.assessment_task_link_asmt_form_result_with_http_info(id, form_result_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id:  (required)
        :param str form_result_id:  (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'form_result_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method assessment_task_link_asmt_form_result" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `assessment_task_link_asmt_form_result`")
        # verify the required parameter 'form_result_id' is set
        if ('form_result_id' not in params) or (params['form_result_id'] is None):
            raise ValueError("Missing the required parameter `form_result_id` when calling `assessment_task_link_asmt_form_result`")

        resource_path = '/api/v2/assessmenttask/{id}/linkformresult/{formResultId}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']
        if 'form_result_id' in params:
            path_params['formResultId'] = params['form_result_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='SystemObject',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def assessment_task_put(self, id, task, **kwargs):
        """
        Gets details of a given assessment task
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.assessment_task_put(id, task, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Assessment task id (required)
        :param Assetic3IntegrationRepresentationsAsmtTaskRepresentation task:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.assessment_task_put_with_http_info(id, task, **kwargs)
        else:
            (data) = self.assessment_task_put_with_http_info(id, task, **kwargs)
            return data

    def assessment_task_put_with_http_info(self, id, task, **kwargs):
        """
        Gets details of a given assessment task
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.assessment_task_put_with_http_info(id, task, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Assessment task id (required)
        :param Assetic3IntegrationRepresentationsAsmtTaskRepresentation task:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'task']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method assessment_task_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `assessment_task_put`")
        # verify the required parameter 'task' is set
        if ('task' not in params) or (params['task'] is None):
            raise ValueError("Missing the required parameter `task` when calling `assessment_task_put`")

        resource_path = '/api/v2/assessmenttask/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'task' in params:
            body_params = params['task']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))
