# coding: utf-8

"""
    Assetic Integration API

    No descripton provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class SearchApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def search_get(self, **kwargs):
        """
        Gets advance search profile results(top 10,000).                 Default Page Size is 20 and Max Page Size is 500.
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.search_get(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str request_params_id: 
        :param int request_params_search_type: 
        :param str request_params_source_tile_id: 
        :param int request_params_page: 
        :param int request_params_page_size: 
        :param list[str] request_params_sorts: 
        :param list[str] request_params_filters: 
        :return: Assetic3IntegrationRepresentationsSearchRepresentationList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.search_get_with_http_info(**kwargs)
        else:
            (data) = self.search_get_with_http_info(**kwargs)
            return data

    def search_get_with_http_info(self, **kwargs):
        """
        Gets advance search profile results(top 10,000).                 Default Page Size is 20 and Max Page Size is 500.
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.search_get_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str request_params_id: 
        :param int request_params_search_type: 
        :param str request_params_source_tile_id: 
        :param int request_params_page: 
        :param int request_params_page_size: 
        :param list[str] request_params_sorts: 
        :param list[str] request_params_filters: 
        :return: Assetic3IntegrationRepresentationsSearchRepresentationList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_params_id', 'request_params_search_type', 'request_params_source_tile_id', 'request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method search_get" % key
                )
            params[key] = val
        del params['kwargs']

        resource_path = '/api/v2/search'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'request_params_id' in params:
            query_params['requestParams.id'] = params['request_params_id']
        if 'request_params_search_type' in params:
            query_params['requestParams.searchType'] = params['request_params_search_type']
        if 'request_params_source_tile_id' in params:
            query_params['requestParams.sourceTileId'] = params['request_params_source_tile_id']
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/hal+json', 'application/hal+xml'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Assetic3IntegrationRepresentationsSearchRepresentationList',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def search_get_geo_json_result(self, **kwargs):
        """
        Gets advance search profile results(top 10,000) in GeoJSON format.                 Default Page Size is 20 and Max Page Size is 500.
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.search_get_geo_json_result(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str request_params_id: 
        :param int request_params_search_type: 
        :param str request_params_source_tile_id: 
        :param int request_params_page: 
        :param int request_params_page_size: 
        :param list[str] request_params_sorts: 
        :param list[str] request_params_filters: 
        :return: Assetic3IntegrationRepresentationsGeoJsonSearchRepresentationList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.search_get_geo_json_result_with_http_info(**kwargs)
        else:
            (data) = self.search_get_geo_json_result_with_http_info(**kwargs)
            return data

    def search_get_geo_json_result_with_http_info(self, **kwargs):
        """
        Gets advance search profile results(top 10,000) in GeoJSON format.                 Default Page Size is 20 and Max Page Size is 500.
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.search_get_geo_json_result_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str request_params_id: 
        :param int request_params_search_type: 
        :param str request_params_source_tile_id: 
        :param int request_params_page: 
        :param int request_params_page_size: 
        :param list[str] request_params_sorts: 
        :param list[str] request_params_filters: 
        :return: Assetic3IntegrationRepresentationsGeoJsonSearchRepresentationList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_params_id', 'request_params_search_type', 'request_params_source_tile_id', 'request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method search_get_geo_json_result" % key
                )
            params[key] = val
        del params['kwargs']

        resource_path = '/api/v2/search/GeoJson'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'request_params_id' in params:
            query_params['requestParams.id'] = params['request_params_id']
        if 'request_params_search_type' in params:
            query_params['requestParams.searchType'] = params['request_params_search_type']
        if 'request_params_source_tile_id' in params:
            query_params['requestParams.sourceTileId'] = params['request_params_source_tile_id']
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/hal+json', 'application/hal+xml'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Assetic3IntegrationRepresentationsGeoJsonSearchRepresentationList',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))
